//***********************************************
//* Simple Snow
//* Snow Effect by Kurt Grigg at http://www.btinternet.com/~kurt.grigg/javascript -->
//* Script featured & available at Code Pen at: https://codepen.io/Griggy/pen/MJOGMx -->
//* Please keep this notice intact 
// ***********************************************
(function() {
//Anzahl der Flocken Standard = 700
    var flakeNum = 50;
    var pic = new Image(20,20);
//die Flocke Standard = schnee/flake.png
    pic.src = "schnee/flake.png";

    var h, w, flks = [],ypos = [],xpos = [],ys = [],xs = [],ye = [],xe = [],fall = [],dim = [],rate = [],d = document;

    var con = d.createElement('div');
    con.setAttribute('style','display:block;'
    +'position:fixed;'
    +'height:100%;width:100%;'
    +'margin:auto;padding:0px;'
    +'top:0;left:0;left:0;right:0;'
    +'overflow:hidden;' 
    +'visibility:hidden;');
    d.body.appendChild(con);

    for (var i = 0; i < flakeNum; i++) {
        var img = d.createElement('img');
        img.setAttribute('id','snowflakes'+i);
        img.setAttribute('src',pic.src);
        img.setAttribute('style','display:block;'
        +'position:absolute;'
        +'transform: translate3d(0px,0px,0);'
        +'visibility:visible;');
        con.appendChild(img);
    }

    function win() {
        var ddw = d.documentElement.clientWidth;
        var ddh = d.documentElement.clientHeight;
        var scrollBarRight = (typeof ddw == 'number') ? window.innerWidth - ddw : 0;
        var scrollBarBottom = (typeof ddh == 'number') ? window.innerHeight - ddh : 0;
        h = window.innerHeight - scrollBarBottom -1;
        w = window.innerWidth - scrollBarRight -1;
    }

    function dst(ax,ay,bx,by) {
        return Math.sqrt((ax-=bx)*ax + (ay-=by)*ay);
    }
//Groesse des Schnees return 30 = Standard - return 70 = Originalgroesse der Flocke
    function prcntg(x) {
        return 30 * x / 100;
    }

    function rst(v) {
        ys[v] = -300 + Math.random() * h + 200;
        ye[v] = ys[v] + (200 + Math.random() * 1500);
        xs[v] = Math.random() * w;
        xe[v] = xs[v] + (-400 + Math.random() * 800);
        fall[v] = (prcntg(0.3) * dst(xe[v],ye[v],xs[v],ys[v]) / 100);
        rate[v] = Math.random() * 8;
    }

    function snowfall() {
        for (var i = 0; i < flakeNum; i++) {
            ye[i] -= rate[i];
            ypos[i] = (ys[i] += (ye[i] - ys[i]) * 0.005);       
            xpos[i] = (xs[i] += (xe[i] - xs[i]) * 0.005);
            dim[i] = (fall[i] * dst(xe[i],ye[i],xs[i],ys[i]) / 100);
            flks[i].transform = 'translate3d('+xpos[i]+'px, '+ypos[i]+'px,0) scale('+(dim[i]*0.035)+')';
            if (dim[i] < prcntg(10) || ypos[i] > h || xpos[i] < 0 || xpos[i] > w) {
                rst(i);
            }
        }
    }

    function run() {
        setTimeout(function() {
            requestAnimationFrame(run);
            snowfall();
        }, 30);
    }

    function init() {
        win();
        for (var i = 0; i < flakeNum; i++){
            flks[i] = d.getElementById("snowflakes"+i).style;
            rst(i);
        }
        run();
    }

    window.addEventListener("resize",win,false);
    window.addEventListener("load",init,false);
})();